//------------------------------------------------------------------------------
//  <copyright from='2004' to='2005' company='WoWSharp.NET'>
//    Copyright (c) WoWSharp.NET. All Rights Reserved.
//
//    Please look in the accompanying license.htm file for the license that 
//    applies to this source code. (a copy can also be found at: 
//    http://www.wowsharp.net/license.htm)
//  </copyright>
//-------------------------------------------------------------------------------
using System;
using System.Collections;

namespace WoW_Sharp
{
	/// <summary>
	/// This object handles all the offsets used by WoW Sharp. If a pointer isnt in the hashtable,
	/// it will be loaded from the website.
	/// </summary>
	internal class WoW_Offsets
	{
		private Hashtable offsets;
		private WoW_WSSClient _wssc;

		private WoW owner;
		internal WoW_Offsets( WoW owner, WoW_WSSClient wssc)
		{
			_wssc = wssc;

			this.owner = owner;

			offsets = new Hashtable();
			_wssc.GetHashtable( "OFFSETS", offsets);
		}

		/// <summary>
		/// Returns an offset, loads it from the website if needed.
		/// </summary>
		/// <param name="offset">Offset name</param>
		/// <returns>Offset</returns>
		internal int getOffset( string offset)
		{
			if( !offsets.ContainsKey( offset))
				throw( new Exception( "Invalid offset"));

			return (int) offsets[ offset];
		}
	}
}
